<template>
  <div>
    <div class="card-container">
      <div v-for="offer in offers" :key="offer.id" class="card">
        <div class="card-header">
          <img :src="buildImgUrl(offer.category)" alt="" class="offer-image" />
          <h2 class="offer-title">{{ offer.title }}</h2>
        </div>
        <div class="card-body">
          <img
            src="@/static/img/profile_picture.jpg"
            alt=""
            class="user-image"
          />
          <p class="user-name">
            <nuxt-link
              class="user-name-link"
              :to="'users/' + offer.User.user_id"
              >{{ offer.User.user_name }}</nuxt-link
            >
          </p>

          <p class="offer-description">{{ offer.description }}</p>
          <ul class="button-list">
            <li class="button-item">
              <!-- VIEW MORE -->
              <nuxt-link class="button-link" :to="'/offers/' + offer.offer_id"
                ><svg viewBox="0 0 512 512" class="item-svg">
                  <path
                    fill="currentColor"
                    class="icon-primary"
                    d="m135 308.5h377v-105h-377zm30-75h317v45h-317z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="m52.5 203.5c-28.949 0-52.5 23.551-52.5 52.5s23.551 52.5 52.5 52.5 52.5-23.551 52.5-52.5-23.551-52.5-52.5-52.5zm0 75c-12.407 0-22.5-10.093-22.5-22.5s10.093-22.5 22.5-22.5 22.5 10.093 22.5 22.5-10.093 22.5-22.5 22.5z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-primary"
                    d="m135 443.5h377v-105h-377zm30-75h317v45h-317z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="m52.5 338.5c-28.949 0-52.5 23.551-52.5 52.5s23.551 52.5 52.5 52.5 52.5-23.551 52.5-52.5-23.551-52.5-52.5-52.5zm0 75c-12.407 0-22.5-10.093-22.5-22.5s10.093-22.5 22.5-22.5 22.5 10.093 22.5 22.5-10.093 22.5-22.5 22.5z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-primary"
                    d="m135 68.5v105h377v-105zm347 75h-317v-45h317z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="m52.5 68.5c-28.949 0-52.5 23.551-52.5 52.5s23.551 52.5 52.5 52.5 52.5-23.551 52.5-52.5-23.551-52.5-52.5-52.5zm0 75c-12.407 0-22.5-10.093-22.5-22.5s10.093-22.5 22.5-22.5 22.5 10.093 22.5 22.5-10.093 22.5-22.5 22.5z"
                  /></svg
              ></nuxt-link>
            </li>
            <li
              v-if="
                $store.state.store.user.user_id == offer.User.user_id ||
                  $store.state.store.user.isAdmin
              "
              class="button-item button-item-edit"
            >
              <!-- EDIT -->
              <a
                href="#"
                class="button-link"
                @click="openModal(offer.offer_id)"
              >
                <svg viewBox="0 0 512 512" class="item-svg">
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="M352.459,220c0-11.046-8.954-20-20-20h-206c-11.046,0-20,8.954-20,20s8.954,20,20,20h206
				            C343.505,240,352.459,231.046,352.459,220z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="M126.459,280c-11.046,0-20,8.954-20,20c0,11.046,8.954,20,20,20H251.57c11.046,0,20-8.954,20-20c0-11.046-8.954-20-20-20
				            H126.459z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-primary"
                    d="M173.459,472H106.57c-22.056,0-40-17.944-40-40V80c0-22.056,17.944-40,40-40h245.889c22.056,0,40,17.944,40,40v123
                    c0,11.046,8.954,20,20,20c11.046,0,20-8.954,20-20V80c0-44.112-35.888-80-80-80H106.57c-44.112,0-80,35.888-80,80v352
                    c0,44.112,35.888,80,80,80h66.889c11.046,0,20-8.954,20-20C193.459,480.954,184.505,472,173.459,472z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-primary"
                    d="M467.884,289.572c-23.394-23.394-61.458-23.395-84.837-0.016l-109.803,109.56c-2.332,2.327-4.052,5.193-5.01,8.345
                    l-23.913,78.725c-2.12,6.98-0.273,14.559,4.821,19.78c3.816,3.911,9,6.034,14.317,6.034c1.779,0,3.575-0.238,5.338-0.727
                    l80.725-22.361c3.322-0.92,6.35-2.683,8.79-5.119l109.573-109.367C491.279,351.032,491.279,312.968,467.884,289.572z
                    M333.776,451.768l-40.612,11.25l11.885-39.129l74.089-73.925l28.29,28.29L333.776,451.768z M439.615,346.13l-3.875,3.867
                    l-28.285-28.285l3.862-3.854c7.798-7.798,20.486-7.798,28.284,0C447.399,325.656,447.399,338.344,439.615,346.13z"
                  />
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="M332.459,120h-206c-11.046,0-20,8.954-20,20s8.954,20,20,20h206c11.046,0,20-8.954,20-20S343.505,120,332.459,120z"
                  /></svg
              ></a>
            </li>
            <li
              v-if="
                $store.state.store.user.user_id == offer.User.user_id ||
                  $store.state.store.user.isAdmin
              "
              class="button-item button-item-delete"
            >
              <!-- DELETE -->
              <a href="#" class="button-link" @click="openAlert(offer)"
                ><svg viewBox="0 0 512 512" class="item-svg">
                  <path
                    fill="currentColor"
                    class="icon-primary"
                    d="m416.875 114.441406-11.304688-33.886718c-4.304687-12.90625-16.339843-21.578126-29.941406-21.578126h-95.011718v-30.933593c0-15.460938-12.570313-28.042969-28.027344-28.042969h-87.007813c-15.453125 0-28.027343 12.582031-28.027343 28.042969v30.933593h-95.007813c-13.605469 0-25.640625 8.671876-29.945313 21.578126l-11.304687 33.886718c-2.574219 7.714844-1.2695312 16.257813 3.484375 22.855469 4.753906 6.597656 12.445312 10.539063 20.578125 10.539063h11.816406l26.007813 321.605468c1.933594 23.863282 22.183594 42.558594 46.109375 42.558594h204.863281c23.921875 0 44.175781-18.695312 46.105469-42.5625l26.007812-321.601562h6.542969c8.132812 0 15.824219-3.941407 20.578125-10.535157 4.753906-6.597656 6.058594-15.144531 3.484375-22.859375zm-249.320312-84.441406h83.0625v28.976562h-83.0625zm162.804687 437.019531c-.679687 8.402344-7.796875 14.980469-16.203125 14.980469h-204.863281c-8.40625 0-15.523438-6.578125-16.203125-14.980469l-25.816406-319.183593h288.898437zm-298.566406-349.183593 9.269531-27.789063c.210938-.640625.808594-1.070313 1.484375-1.070313h333.082031c.675782 0 1.269532.429688 1.484375 1.070313l9.269531 27.789063zm0 0"
                  />
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="m282.515625 465.957031c.265625.015625.527344.019531.792969.019531 7.925781 0 14.550781-6.210937 14.964844-14.21875l14.085937-270.398437c.429687-8.273437-5.929687-15.332031-14.199219-15.761719-8.292968-.441406-15.328125 5.925782-15.761718 14.199219l-14.082032 270.398437c-.429687 8.273438 5.925782 15.332032 14.199219 15.761719zm0 0"
                  />
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="m120.566406 451.792969c.4375 7.996093 7.054688 14.183593 14.964844 14.183593.273438 0 .554688-.007812.832031-.023437 8.269531-.449219 14.609375-7.519531 14.160157-15.792969l-14.753907-270.398437c-.449219-8.273438-7.519531-14.613281-15.792969-14.160157-8.269531.449219-14.609374 7.519532-14.160156 15.792969zm0 0"
                  />
                  <path
                    fill="currentColor"
                    class="icon-secondary"
                    d="m209.253906 465.976562c8.285156 0 15-6.714843 15-15v-270.398437c0-8.285156-6.714844-15-15-15s-15 6.714844-15 15v270.398437c0 8.285157 6.714844 15 15 15zm0 0"
                  /></svg
              ></a>
            </li>
          </ul>
        </div>
      </div>
    </div>
    <transition v-if="showModal" name="modal-fade">
      <div class="modal-backdrop">
        <div
          class="modal"
          role="dialog"
          aria-labelledby="modalTitle"
          aria-describedby="modalDescription"
        >
          <v-container>
            <v-select
              v-model="offerToUpdate.category"
              :items="categories"
              label="Category"
              outlined
              >{{ offerToUpdate.category }}</v-select
            >
            <v-text-field
              v-model="offerToUpdate.title"
              outlined
              label="Title"
              clearable
              >{{ offerToUpdate.title }}</v-text-field
            >
            <v-textarea
              v-model="offerToUpdate.description"
              outlined
              label="Description"
              clearable
              auto-grow
              >{{ offerToUpdate }}</v-textarea
            >
            <!-- <v-text-field
              v-model="offerToUpdate.location"
              outlined
              label="Location"
            ></v-text-field>
            <v-dialog
              ref="dialog_date"
              v-model="modal_date"
              :return-value.sync="date"
              width="290px"
              persistent
            >
              <template v-slot:activator="{ on, attrs }">
                <v-text-field
                  v-model="date"
                  label="Date"
                  readonly
                  outlined
                  v-bind="attrs"
                  v-on="on"
                ></v-text-field>
              </template>
              <v-date-picker v-model="date" scrollable outlined>
                <v-btn text color="primary" @click="modal_date = false"
                  >Cancel</v-btn
                >
                <v-btn
                  text
                  color="primary"
                  @click="$refs.dialog_date.save(date)"
                  >OK</v-btn
                >
              </v-date-picker>
            </v-dialog>
            <v-dialog
              ref="dialog_time"
              v-model="modal_time"
              :return-value.sync="time"
              persistent
              width="290px"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-text-field
                  v-model="time"
                  label="Time"
                  readonly
                  outlined
                  v-bind="attrs"
                  v-on="on"
                ></v-text-field>
              </template>
              <v-time-picker
                v-if="modal_time"
                v-model="time"
                format="24hr"
                scrollable
              >
                <v-btn text color="primary" @click="modal_time = false"
                  >Cancel</v-btn
                >
                <v-btn
                  text
                  color="primary"
                  @click="$refs.dialog_time.save(time)"
                  >OK</v-btn
                >
              </v-time-picker>
            </v-dialog> -->
            <v-btn outlined @click="update">Update Offer</v-btn>
            <br />
            <v-btn outlined @click="close">Close</v-btn>
            <span v-if="error" class="error">{{ error }}</span>
            <span v-if="success" class="success">{{ success }}</span>
          </v-container>
        </div>
      </div>
    </transition>
  </div>
</template>

<script>
import OffersService from '@/services/OffersService'
export default {
  data() {
    return {
      showModal: false,
      offers: [],
      offerToUpdate: [],
      categories: [
        { text: 'mowing', value: 'mowing' },
        { text: 'shopping', value: 'shopping' },
        { text: 'others', value: 'others' }
      ],
      error: null,
      success: null
    }
  },
  async mounted() {
    this.offers = (await OffersService.index()).data
  },
  methods: {
    buildImgUrl(name) {
      if (name) {
        return require(`@/static/img/${name}_01.jpg`)
      }
    },
    async openModal(offerID) {
      this.offerToUpdate = (await OffersService.getOfferById(offerID)).data[0]
      this.showModal = true
    },
    async update() {
      this.error = null
      if (
        this.offerToUpdate.title === '' ||
        this.offerToUpdate.description === ''
      ) {
        this.error = 'Please fill in all the fields.'
        return
      }
      try {
        await OffersService.update(this.offerToUpdate)
        this.showModal = false
        this.offers = (await OffersService.index()).data
      } catch (err) {
        this.error = err
      }
    },
    openAlert(offer) {
      const result = confirm(
        `Are you sure you want ot delete the offer "${offer.title}"?`
      )
      if (result) {
        this.delete(offer)
      }
    },
    async delete(offer) {
      try {
        await OffersService.delete(offer)
        this.showModal = false
        this.offers = (await OffersService.index()).data
      } catch (err) {
        this.error = err
      }
    },
    close() {
      this.showModal = false
    }
  }
}
</script>

<style scoped>
* {
  box-sizing: border-box;
}

.card-container {
  display: flex;
  flex-wrap: wrap;
}

.card {
  position: relative;
  box-shadow: var(--box-shadow);
  border-radius: var(--border-radius);
  border: var(--border);
  min-width: 250px;
  min-height: 350px;
  max-height: 50vh;
  margin: 0.5rem;
  display: flex;
  flex-direction: column;
  flex-basis: auto;
  flex-grow: 1;
  flex-shrink: 1;
  background: var(--bg-primary);
  color: var(--text-primary);
  text-align: center;
  padding-bottom: 0.5rem;
}

.card:hover,
.card:focus {
  box-shadow: var(--box-shadow-hover);
}

.card-header {
  position: relative;
  min-height: 150px;
  max-height: 20vh;
  border-radius: 5px var(--border-radius) 0px 0px;
}

.offer-image {
  position: absolute;
  border-radius: var(--border-radius) var(--border-radius) 0px 0px;
  object-fit: cover;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  text-align: center;
}

.offer-title {
  position: absolute;
  color: var(--text-primary);
  font-size: clamp(1rem, 1.5rem, 2rem);
  text-transform: uppercase;
  width: 100%;
  padding: 0.1em;
  max-height: 19vh;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
}

.card-body {
  position: relative;
  min-height: 200px;
  max-height: 30vh;
}

.user-image {
  position: absolute;
  top: -3em;
  left: 0.5em;
  height: 100px;
  border-radius: 50%;
  border: var(--border);
  object-fit: cover;
  background-position: center;
}

.user-name {
  position: absolute;
  left: 120px;
  top: 0;
}

.user-name-link {
  text-decoration: none;
  color: var(--accent-light);
}

.offer-description {
  padding-top: 5em;
  padding-left: 2em;
  padding-right: 2em;
  font-size: clamp(0.5rem, 1rem, 1.5rem);
}

.button-list {
  position: absolute;
  bottom: 0.5em;
  list-style: none;
  display: flex;
  width: 90%;
  justify-content: space-around;
}

.button-item {
  border-radius: var(--border-radius);
  background: var(--accent-light);
  min-width: 70px;
  max-width: 4vw;
}

.button-item-edit {
  background: gray;
}

.button-item-delete {
  background: rgb(255, 115, 115);
}

.button-link {
  color: black;
  text-decoration: none;
}

.item-svg {
  margin-top: 5px;
  margin-bottom: 5px;
  width: 25px;
}

.modal-backdrop {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: rgba(0, 0, 0, 0.25);
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal {
  position: absolute;
  left: calc(25vw + (var(--width-sidebar) / 2));
  height: 60vh;
  width: 50vw;
  box-shadow: 2px 2px 20px 1px;
  overflow: auto;
  display: flex;
  flex-direction: column;
  border-radius: var(--border-radius);
  color: var(--text-primary);
  background: var(--bg-primary);
}

.modal-fade-enter,
.modal-fade-leave-active {
  opacity: 0;
}

.modal-fade-enter-active,
.modal-fade-leave-active {
  transition: opacity 0.5s ease;
}
@media only screen and (max-width: 813px) {
  .card-container {
    padding-bottom: var(--height-sidebar);
  }
}
</style>
